//------------------------------------------------------------------
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DimGray
#property indicator_color2  DimGray
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern int    VolatilityPeriod       = 10;
extern double VolatilityPercent      = 0.5;
extern int    VolatilityDisplacement =  1;
extern int    MinMaxPeriod           =  6;
extern int    MinMaxDisplacement     =  1;

double bandUp[];
double bandDn[];
double arrUp[];
double arrDn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bandUp);
   SetIndexBuffer(1,bandDn);
   SetIndexBuffer(2,arrUp); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
   SetIndexBuffer(3,arrDn); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   double percent = VolatilityPercent/100.0;
   for(int i=limit; i>=0; i--)
   {
      bandUp[i] = High[ArrayMaximum(High,MinMaxPeriod,i+MinMaxDisplacement)];
      bandDn[i] = Low[ArrayMinimum(Low,MinMaxPeriod,i+MinMaxDisplacement)];
      arrUp[i]  = EMPTY_VALUE;
      arrDn[i]  = EMPTY_VALUE;
      
         //
         //
         //
         //
         //
 
         double sumr = 0;
         double sump = 0;        
         for (int k=0; k<VolatilityPeriod; k++)
         {
            sumr += (High[i+k+VolatilityDisplacement]-Low[i+k+VolatilityDisplacement]);
            sump += Close[i+k+VolatilityDisplacement];
         }
         if (sump!=0)
               double volat = sumr/sump;
         else         volat = 1;
         if (volat>percent && Close[i]>bandUp[i]) arrUp[i] = High[i];
         if (volat>percent && Close[i]<bandDn[i]) arrDn[i] = Low[i];
   }
   Print(DoubleToStr(volat,6));
   return(0);
}